'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

function _interopDefault (ex) { return (ex && (typeof ex === 'object') && 'default' in ex) ? ex['default'] : ex; }

var PropTypes = _interopDefault(require('prop-types'));
var React = _interopDefault(require('react'));

var If = function If(_ref) {
  var when = _ref.when,
      children = _ref.children;

  if (when) {
    return children;
  }
  return null;
};
If.propTypes = {
  when: PropTypes.any.isRequired
};

var Case = function Case(_ref) {
  var children = _ref.children;

  return children;
};

var Default = function Default(_ref) {
  var children = _ref.children;

  return children;
};

var Switch = function Switch(_ref) {
  var value = _ref.value,
      children = _ref.children;

  var defaultComponent = null;
  var caseComponent = null;
  React.Children.forEach(children, function (child) {
    if (child.type === Default) {
      defaultComponent = child;
    } else if (child.type === Case && value === child.props.when) {
      caseComponent = child;
    }
  });
  if (caseComponent) {
    return caseComponent;
  } else if (defaultComponent) {
    return defaultComponent;
  }
  return null;
};
Switch.propTypes = {
  value: PropTypes.any.isRequired
};

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) {
  return typeof obj;
} : function (obj) {
  return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj;
};











var classCallCheck = function (instance, Constructor) {
  if (!(instance instanceof Constructor)) {
    throw new TypeError("Cannot call a class as a function");
  }
};

var createClass = function () {
  function defineProperties(target, props) {
    for (var i = 0; i < props.length; i++) {
      var descriptor = props[i];
      descriptor.enumerable = descriptor.enumerable || false;
      descriptor.configurable = true;
      if ("value" in descriptor) descriptor.writable = true;
      Object.defineProperty(target, descriptor.key, descriptor);
    }
  }

  return function (Constructor, protoProps, staticProps) {
    if (protoProps) defineProperties(Constructor.prototype, protoProps);
    if (staticProps) defineProperties(Constructor, staticProps);
    return Constructor;
  };
}();







var _extends = Object.assign || function (target) {
  for (var i = 1; i < arguments.length; i++) {
    var source = arguments[i];

    for (var key in source) {
      if (Object.prototype.hasOwnProperty.call(source, key)) {
        target[key] = source[key];
      }
    }
  }

  return target;
};



var inherits = function (subClass, superClass) {
  if (typeof superClass !== "function" && superClass !== null) {
    throw new TypeError("Super expression must either be null or a function, not " + typeof superClass);
  }

  subClass.prototype = Object.create(superClass && superClass.prototype, {
    constructor: {
      value: subClass,
      enumerable: false,
      writable: true,
      configurable: true
    }
  });
  if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass;
};











var possibleConstructorReturn = function (self, call) {
  if (!self) {
    throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
  }

  return call && (typeof call === "object" || typeof call === "function") ? call : self;
};



















var toConsumableArray = function (arr) {
  if (Array.isArray(arr)) {
    for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) arr2[i] = arr[i];

    return arr2;
  } else {
    return Array.from(arr);
  }
};

function isObject(val) {
  return val != null && (typeof val === 'undefined' ? 'undefined' : _typeof(val)) === 'object' && Array.isArray(val) === false;
}

var For = function (_React$Component) {
  inherits(For, _React$Component);

  function For() {
    classCallCheck(this, For);
    return possibleConstructorReturn(this, (For.__proto__ || Object.getPrototypeOf(For)).apply(this, arguments));
  }

  createClass(For, [{
    key: 'render',
    value: function render() {
      var _props = this.props,
          children = _props.children,
          of = _props.of;

      var renderMethod = null;
      var defaultComponent = null;
      var renderItems = null;
      if (!React.Children.count(children)) {
        renderMethod = children;
      } else {
        children.forEach(function (child) {
          if (child.type === Default) {
            defaultComponent = child;
          } else if (typeof child === 'function') {
            renderMethod = child;
          }
        });
      }
      if (Array.isArray(of)) {
        var items = [].concat(toConsumableArray(of));
        renderItems = items.map(function (item, index) {
          return renderMethod(item, index);
        });
      } else if (isObject(of)) {
        var _items = _extends({}, of);
        var keys = Object.keys(_items);
        renderItems = keys.map(function (key, index) {
          return renderMethod(_items[key], index, key);
        });
      }
      if (renderItems && renderItems.length) {
        return renderItems;
      } else if (defaultComponent) {
        return React.cloneElement(defaultComponent);
      }
      return null;
    }
  }]);
  return For;
}(React.Component);

For.propTypes = {
  of: PropTypes.oneOfType([PropTypes.array, PropTypes.object])
};

exports.If = If;
exports.Switch = Switch;
exports.Case = Case;
exports.Default = Default;
exports.For = For;
